Foxit PDF SDK

Public Member Functions | Static Public Attributes | List of all members
com.foxit.sdk.pdf.annots.Widget Class Reference
Inheritance diagram for com.foxit.sdk.pdf.annots.Widget:

## Public Member Functions
| Widget ()
| Constructor.
| Widget (Annot annot)
| Constructor, with parent class object. More...
synchronized void | delete ()
| Clean up related C++ resources immediately. More...
Action | getAction () throws com.foxit.sdk.PDFException
| Get action. More...
String | getAppearanceOnStateName () throws com.foxit.sdk.PDFException
| Get the name of the annotation's appearance "ON" state. More...
String | getAppearanceState () throws com.foxit.sdk.PDFException
| Get the annotation's appearance state, which selects the applicable appearance stream from an appearance subdictionary. More...
Control | getControl () throws com.foxit.sdk.PDFException
| Get associated form control. More...
Field | getField () throws com.foxit.sdk.PDFException
| Get associated form field. More...
int | getHighlightingMode () throws com.foxit.sdk.PDFException
| Get highlighting mode. More...
int | getLineSpacing (java.lang.Float line_spacing_value) throws com.foxit.sdk.PDFException
| Get line spacing of current widget. More...
long | getMKBackgroundColor () throws com.foxit.sdk.PDFException
| Get the background color in the MK dictionary. More...
long | getMKBorderColor () throws com.foxit.sdk.PDFException
| Get the border color in the MK dictionary. More...
String | getMKDownCaption () throws com.foxit.sdk.PDFException
| Get the down caption string in the MK dictionary. More...
Bitmap | getMKDownIconBitmap () throws com.foxit.sdk.PDFException
| Get the down icon bitmap in the MK dictionary. More...
int | getMKIconCaptionRelation () throws com.foxit.sdk.PDFException
| Get the relation of icon and caption in the MK dictionary. More...
IconFit | getMKIconFit () throws com.foxit.sdk.PDFException
| Get the icon fit information in the MK dictionary. More...
String | getMKNormalCaption () throws com.foxit.sdk.PDFException
| Get the normal caption string in the MK dictionary. More...
Bitmap | getMKNormalIconBitmap () throws com.foxit.sdk.PDFException
| Get the normal icon bitmap in the MK dictionary. More...
String | getMKRolloverCaption () throws com.foxit.sdk.PDFException
| Get the rollover caption string in the MK dictionary. More...
Bitmap | getMKRolloverIconBitmap () throws com.foxit.sdk.PDFException
| Get the rollover icon bitmap in the MK dictionary. More...
int | getMKRotation () throws com.foxit.sdk.PDFException
| Get the rotation value in the MK dictionary. More...
boolean | hasMKEntry (int mk_entry) throws com.foxit.sdk.PDFException
| Check if a specified entry exists in the MK dictionary. More...
void | removeAction () throws com.foxit.sdk.PDFException
| Remove action. More...
void | removeMKEntry (int mk_entry) throws com.foxit.sdk.PDFException
| Remove a specified entry from the MK dictionary. More...
void | setAction (Action action) throws com.foxit.sdk.PDFException
| Set action. More...
void | setAppearanceState (String appearance_state) throws com.foxit.sdk.PDFException
| Set the annotation's appearance state, which selects the applicable appearance stream from an appearance subdictionary. More...
void | setHighlightingMode (int mode) throws com.foxit.sdk.PDFException
| Set highlighting mode. More...
void | setLineSpacing (int line_spacing_style, float line_spacing_value) throws com.foxit.sdk.PDFException
| Set line spacing for current widget. More...
void | setMKBackgroundColor (long color) throws com.foxit.sdk.PDFException
| Set the background color in the MK dictionary. More...
void | setMKBorderColor (long color) throws com.foxit.sdk.PDFException
| Set the border color in the MK dictionary. More...
void | setMKDownCaption (String caption) throws com.foxit.sdk.PDFException
| Set the down caption string in the MK dictionary. More...
void | setMKDownIconBitmap (Bitmap bitmap) throws com.foxit.sdk.PDFException
| Set the down icon bitmap in the MK dictionary. More...
void | setMKDownIconImage (Image image, int frame_index) throws com.foxit.sdk.PDFException
| Set an image with specified frame index as down icon in the MK dictionary. More...
void | setMKIconCaptionRelation (int relation) throws com.foxit.sdk.PDFException
| Set the relation of icon and caption in the MK dictionary. More...
void | setMKIconFit (IconFit icon_fit) throws com.foxit.sdk.PDFException
| Set the icon fit information in the MK dictionary. More...
void | setMKNormalCaption (String caption) throws com.foxit.sdk.PDFException
| Set the normal caption string in the MK dictionary. More...
void | setMKNormalIconBitmap (Bitmap bitmap) throws com.foxit.sdk.PDFException
| Set a bitmap as normal icon in the MK dictionary. More...
void | setMKNormalIconImage (Image image, int frame_index) throws com.foxit.sdk.PDFException
| Set an image with specified frame index as normal icon in the MK dictionary. More...
void | setMKRolloverCaption (String caption) throws com.foxit.sdk.PDFException
| Set the rollover caption string in the MK dictionary. More...
void | setMKRolloverIconBitmap (Bitmap bitmap) throws com.foxit.sdk.PDFException
| Set the rollover icon bitmap in the MK dictionary. More...
void | setMKRolloverIconImage (Image image, int frame_index) throws com.foxit.sdk.PDFException
| Set an image with specified frame index as rollover icon in the MK dictionary. More...
void | setMKRotation (int rotation) throws com.foxit.sdk.PDFException
| Set the rotation value in the MK dictionary. More...
Public Member Functions inherited from com.foxit.sdk.pdf.annots.Annot
| Annot ()
| Constructor.
| Annot (Annot annot)
| Constructor, with another annotation object. More...
| Annot (PDFPage page, PDFDictionary annot_dict) throws com.foxit.sdk.PDFException
| Constructor, with PDF page and annotation's PDF dictionary. More...
PDFStream | getAppearanceStream (int type, String appearance_state) throws com.foxit.sdk.PDFException
| Get annotation's appearance stream with specified type and state. More...
long | getBorderColor () throws com.foxit.sdk.PDFException
| Get border color. More...
BorderInfo | getBorderInfo () throws com.foxit.sdk.PDFException
| Get border information. More...
String | getContent () throws com.foxit.sdk.PDFException
| Get content. More...
RectI | getDeviceRect (Matrix2D matrix) throws com.foxit.sdk.PDFException
| Get annotation rectangle in device coordinate system. More...
PDFDictionary | getDict () throws com.foxit.sdk.PDFException
| Get annotation's dictionary object. More...
Matrix2D | getDisplayMatrix (Matrix2D page_display_matrix) throws com.foxit.sdk.PDFException
| Get the display matrix, from PDF coordinate system to targeted device coordinate system. More...
int | getFlags () throws com.foxit.sdk.PDFException
| Get annotation flags. More...
int | getIndex () throws com.foxit.sdk.PDFException
| Get the index of current annotation in the page which current annotation belongs to. More...
DateTime | getModifiedDateTime () throws com.foxit.sdk.PDFException
| Get last modified date time. More...
PDFDictionary | getOptionalContent () throws com.foxit.sdk.PDFException
| Get the PDF dictionary of annotation's optional content. More...
PDFPage | getPage () throws com.foxit.sdk.PDFException
| Get the related PDF page. More...
RectF | getRect () throws com.foxit.sdk.PDFException
| Get rectangle, in PDF coordinate system. More...
int | getType () throws com.foxit.sdk.PDFException
| Get actual annotation type of current annotation. More...
String | getUniqueID () throws com.foxit.sdk.PDFException
| Get unique ID. More...
boolean | hasProperty (int property) throws com.foxit.sdk.PDFException
| Whether current annotation has the specified annotation's property. More...
boolean | isEmpty ()
| Check whether current object is empty or not. More...
boolean | isMarkup () throws com.foxit.sdk.PDFException
| Check if current annotation is a markup annotation. More...
boolean | move (RectF rect) throws com.foxit.sdk.PDFException
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
boolean | move (RectF rect, boolean is_reset_appearance) throws com.foxit.sdk.PDFException
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
boolean | removeProperty (int property) throws com.foxit.sdk.PDFException
| Remove a specified annotation's property. More...
boolean | resetAppearanceStream () throws com.foxit.sdk.PDFException
| Reset appearance stream. More...
boolean | resetAppearanceStream (boolean is_generate_new_appearance_obj) throws com.foxit.sdk.PDFException
| Reset appearance stream. More...
void | setBorderColor (long color) throws com.foxit.sdk.PDFException
| Set border color. More...
void | setBorderInfo (BorderInfo border) throws com.foxit.sdk.PDFException
| Set border information. More...
void | setContent (String content) throws com.foxit.sdk.PDFException
| Set content. More...
void | setFlags (int flags) throws com.foxit.sdk.PDFException
| Set annotation flags. More...
void | setModifiedDateTime (DateTime date_time) throws com.foxit.sdk.PDFException
| Set last modified date time. More...
void | setUniqueID (String unique_id) throws com.foxit.sdk.PDFException
| Set unique ID. More...

## Static Public Attributes
static final int | e_LineSpacingAuto = 4
| Line spacing style: auto line spacing.
static final int | e_LineSpacingDouble = 2
| Line spacing style: double line spacing.
static final int | e_LineSpacingExactValue = 3
| Line spacing style: exact value line spacing.
static final int | e_LineSpacingOneAndHalf = 1
| Line spacing style: one and half times line spacing.
static final int | e_LineSpacingSingle = 0
| Line spacing style: single line spacing.
Static Public Attributes inherited from com.foxit.sdk.pdf.annots.Annot
static final int | e_3D = 25
| Annotation type: 3D annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_AppearanceTypeDown = 2
| Annotation's down appearance.
static final int | e_AppearanceTypeNormal = 0
| Annotation's normal appearance.
static final int | e_AppearanceTypeRollover = 1
| Annotation's rollover appearance.
static final int | e_Caret = 14
| Annotation type: caret annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Circle = 6
| Annotation type: circle annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_FileAttachment = 17
| Annotation type: file attachment annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_FlagHidden = 0x0002
| Annotation flag: hidden. More...
static final int | e_FlagInvisible = 0x0001
| Annotation flag: invisible. More...
static final int | e_FlagLocked = 0x0080
| Annotation flag: locked. More...
static final int | e_FlagLockedContents = 0x0200
| Annotation flag: locked contents. More...
static final int | e_FlagNoRotate = 0x0010
| Annotation flag: no rotate. More...
static final int | e_FlagNoView = 0x0020
| Annotation flag: no view. More...
static final int | e_FlagNoZoom = 0x0008
| Annotation flag: no zoom. More...
static final int | e_FlagPrint = 0x0004
| Annotation flag: print. More...
static final int | e_FlagReadOnly = 0x0040
| Annotation flag: read only. More...
static final int | e_FlagToggleNoView = 0x0100
| Annotation flag: toggle no view. More...
static final int | e_FreeText = 3
| Annotation type: free text annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Highlight = 9
| Annotation type: highlight annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_HighlightingInvert = 1
| Highlighting mode: Invert, which is to invert the contents of the annotation rectangle.
static final int | e_HighlightingNone = 0
| Highlighting mode: No highlighting.
static final int | e_HighlightingOutline = 2
| Highlighting mode: Outline, which is to invert the annotation's border.
static final int | e_HighlightingPush = 3
| Highlighting mode: Push, which is to display the annotation's down appearance, if any.
static final int | e_HighlightingToggle = 4
| Highlighting mode: Toggle. This is only useful for widget annotation.
static final int | e_Ink = 15
| Annotation type: ink annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Line = 4
| Annotation type: line annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Link = 2
| Annotation type: link annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_MKEntryBackgroundColor = 2
| Background color entry. "BG" in MK dictionary.
static final int | e_MKEntryBorderColor = 1
| Border color entry. "BC" in MK dictionary.
static final int | e_MKEntryDownCaption = 5
| Down caption (or alternate caption) entry. "AC" in MK dictionary. More...
static final int | e_MKEntryDownIcon = 8
| Down icon (or alternate icon) entry. "IX" in MK dictionary. More...
static final int | e_MKEntryIconCaptionRelation = 10
| Icon and caption relation entry. "TP" in MK dictionary. More...
static final int | e_MKEntryIconFit = 9
| Icon fit information entry. "IF" in MK dictionary. More...
static final int | e_MKEntryNormalCaption = 3
| Normal caption entry. "CA" in MK dictionary. More...
static final int | e_MKEntryNormalIcon = 6
| Normal icon entry. "I" in MK dictionary. More...
static final int | e_MKEntryRolloverCaption = 4
| Rollover caption entry. "RC" in MK dictionary. More...
static final int | e_MKEntryRolloverIcon = 7
| Rollover icon entry. "RI" in MK dictionary. More...
static final int | e_MKEntryRotation = 0
| Rotation entry. "R" in MK dictionary.
static final int | e_MKRelationCaptionAboveIcon = 3
| Caption above the icon.
static final int | e_MKRelationCaptionBelowIcon = 2
| Caption below the icon.
static final int | e_MKRelationCaptionLeft = 5
| Caption to the left of the icon.
static final int | e_MKRelationCaptionOvrlayOnIcon = 6
| Caption overlaid directly on the icon.
static final int | e_MKRelationCaptionRight = 4
| Caption to the right of the icon.
static final int | e_MKRelationNoCaption = 1
| No caption; icon only.
static final int | e_MKRelationNoIcon = 0
| No icon; captin only.
static final int | e_Movie = 19
| Annotation type: movie annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Note = 1
| Annotation type: note annotation, which is just "Text" annotation - one of standard annotation in <PDF reference 1.7>.
static final int | e_PagingSeal = 29
| Annotation type: paging seal annotation. A Foxit PDF SDK custom annotation type (not a standard annotation type).
static final int | e_Polygon = 7
| Annotation type: polygon annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_PolyLine = 8
| Annotation type: polyline annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Popup = 26
| Annotation type: pop-up annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_PrinterMark = 22
| Annotation type: printer's mark annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_PropertyBorderColor = 2
| Annotation property: border color. More...
static final int | e_PropertyCreationDate = 1
| Annotation property: creation date. More...
static final int | e_PropertyFillColor = 3
| Annotation property: fill color. More...
static final int | e_PropertyModifiedDate = 0
| Annotation property: modified date.
static final int | e_PSInk = 16
| Annotation type: pressure sensitive ink annotation.
static final int | e_Redact = 27
| Annotation type: redact annotation.
static final int | e_RichMedia = 28
| Annotation type: rich media annotation.
static final int | e_Screen = 21
| Annotation type: screen annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Sound = 18
| Annotation type: sound annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Square = 5
| Annotation type: square annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Squiggly = 11
| Annotation type: squiggly annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Stamp = 13
| Annotation type: stamp annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_StrikeOut = 12
| Annotation type: strikeout annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_TrapNet = 23
| Annotation type: trap network annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Underline = 10
| Annotation type: underline annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_UnknownType = 0
| Annotation type: unknown.
static final int | e_Watermark = 24
| Annotation type: watermark annotation. One of standard annotation in <PDF reference 1.7>.
static final int | e_Widget = 20
| Annotation type: widget annotation. One of standard annotation in <PDF reference 1.7>. More...

## Detailed Description

A widget annotation is used to represent the appearance of form fields.
Class com.foxit.sdk.pdf.annots.Widget is derived from class Annot and also offers functions to get/set widget annotation's properties. Functions Widget.getField and Widget.getControl can be used to get the associated form field and form control object. If a widget annotation is not associated with any form field or is associated with a signature field, this widget can still get/set properties, but cannot be reset appearance. For these cases, Annot.resetAppearanceStream (inherited from Widget's parent class) will return false directly.

See also
  Annot
  com.foxit.sdk.pdf.interform.Field
  com.foxit.sdk.pdf.interform.Control

## Constructor & Destructor Documentation

## ◆ Widget()

com.foxit.sdk.pdf.annots.Widget.Widget | ( | Annot | annot | ) |

Constructor, with parent class object.

Parameters

  [in] | annot | Parent class object.

## Member Function Documentation

## ◆ delete()

synchronized void com.foxit.sdk.pdf.annots.Widget.delete | ( |  | ) |

Clean up related C++ resources immediately.

Returns
  None.

Note
  Once this function is called, current object cannot be used anymore.

Reimplemented from com.foxit.sdk.pdf.annots.Annot.

## ◆ getAction()

Action com.foxit.sdk.pdf.annots.Widget.getAction | ( |  | ) | throws com.foxit.sdk.PDFException

Get action.

This function cannot be used to get action which is used as additional action. If user wants to get any additional action, please refer to class com.foxit.sdk.pdf.actions.AdditionalAction for more details.

Returns
  An action object that receives the action data. If the return value of function actions.Action.isEmpty for the returned action object is true, that means no action.

## ◆ getAppearanceOnStateName()

String com.foxit.sdk.pdf.annots.Widget.getAppearanceOnStateName | ( |  | ) | throws com.foxit.sdk.PDFException

Get the name of the annotation's appearance "ON" state.

Returns
  The name of the annotation's appearance "ON" state.

## ◆ getAppearanceState()

String com.foxit.sdk.pdf.annots.Widget.getAppearanceState | ( |  | ) | throws com.foxit.sdk.PDFException

Get the annotation's appearance state, which selects the applicable appearance stream from an appearance subdictionary.

Returns
  The annotation's appearance state.

## ◆ getControl()

Control com.foxit.sdk.pdf.annots.Widget.getControl | ( |  | ) | throws com.foxit.sdk.PDFException

Get associated form control.

Returns
  The associated form control object.

## ◆ getField()

Field com.foxit.sdk.pdf.annots.Widget.getField | ( |  | ) | throws com.foxit.sdk.PDFException

Get associated form field.

Returns
  The associated form field object.

## ◆ getHighlightingMode()

int com.foxit.sdk.pdf.annots.Widget.getHighlightingMode | ( |  | ) | throws com.foxit.sdk.PDFException

Get highlighting mode.

Highlighting mode is the visual effect to be used when the mouse button is pressed or held down inside its active area.

Returns
  Highlighting mode value. Please refer to values starting from com.foxit.sdk.pdf.annots.Annot.e_HighlightingNone and this would be one of these values.

## ◆ getLineSpacing()

int com.foxit.sdk.pdf.annots.Widget.getLineSpacing | ( | java.lang.Float | line_spacing_value | ) | throws com.foxit.sdk.PDFException

Get line spacing of current widget.

This is only applicable for widget associated with text fields which contain the flag com.foxit.sdk.pdf.interform.Field.e_FlagTextMultiline . For other type of fields, this will be useless.

Parameters

  [out] | line_spacing_value | Output parameter that receives the line spacing exact value.

Returns
  Line spacing style. Please refer to values starting from com.foxit.sdk.pdf.annots.Widget.e_LineSpacingSingle and this would be one of these values.

## ◆ getMKBackgroundColor()

long com.foxit.sdk.pdf.annots.Widget.getMKBackgroundColor | ( |  | ) | throws com.foxit.sdk.PDFException

Get the background color in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page.

Returns
  The background color in MK dictionary. Value format: 0xRRGGBB.
  0 may means no background color in MK dictionary. In this case, please call function Widget.hasMKEntry with value com.foxit.sdk.pdf.annots.Annot.e_MKEntryBackgroundColor to check.

## ◆ getMKBorderColor()

long com.foxit.sdk.pdf.annots.Widget.getMKBorderColor | ( |  | ) | throws com.foxit.sdk.PDFException

Get the border color in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page.

Returns
  The border color in MK dictionary. Value format: 0xRRGGBB.
  0 may means no border color in MK dictionary. In this case, please call function Widget.hasMKEntry with value com.foxit.sdk.pdf.annots.Annot.e_MKEntryBorderColor to check.

## ◆ getMKDownCaption()

String com.foxit.sdk.pdf.annots.Widget.getMKDownCaption | ( |  | ) | throws com.foxit.sdk.PDFException

Get the down caption string in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Down caption (or alternate caption) in MK dictionary is used to displayed when the mouse button is pressed within its active area. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Returns
  Down caption string. An empty string may means no down caption in MK dictionary. In this case, please call function Widget.hasMKEntry with value com.foxit.sdk.pdf.annots.Annot.e_MKEntryDownCaption to check.

## ◆ getMKDownIconBitmap()

Bitmap com.foxit.sdk.pdf.annots.Widget.getMKDownIconBitmap | ( |  | ) | throws com.foxit.sdk.PDFException

Get the down icon bitmap in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Down icon (or alternate icon) in MK dictionary is used to displayed when the mouse button is pressed within its active area. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Returns
  Down icon bitmap. If function common.Bitmap.isEmpty for the returned bitmap object returns true, that means current widget annotation does not have down icon bitmap.

## ◆ getMKIconCaptionRelation()

int com.foxit.sdk.pdf.annots.Widget.getMKIconCaptionRelation | ( |  | ) | throws com.foxit.sdk.PDFException

Get the relation of icon and caption in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. The relation position of caption and icon specifies where to position the text of the widget annotation's caption relative to its icon. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Returns
  The relation position of caption and icon. Please refer to com.foxit.sdk.pdf.annots.Annot.e_MKRelationNoIcon values and it should be one of these values.

## ◆ getMKIconFit()

IconFit com.foxit.sdk.pdf.annots.Widget.getMKIconFit | ( |  | ) | throws com.foxit.sdk.PDFException

Get the icon fit information in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. The icon fit information specifies how to display the widget annotation's icon within its annotation rectangle. If present, the icon fit information applies to all of the annotation's icons. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Returns
  An icon fit object, which contains the icon fit information in MK dictionary. If scale way type of icon fit object is value com.foxit.sdk.pdf.annots.IconFit.e_ScaleWayNone , that means no icon fit information in MK dictionary.

## ◆ getMKNormalCaption()

String com.foxit.sdk.pdf.annots.Widget.getMKNormalCaption | ( |  | ) | throws com.foxit.sdk.PDFException

Get the normal caption string in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Normal caption in MK dictionary is used to displayed when the widget is not interacting with the user. This is applicable for widget associated with pushbutton field, check box field or radio button field. For other type of fields, this will be useless.

Returns
  Normal caption string. An empty string may means no normal caption in MK dictionary. In this case, please call function Widget.hasMKEntry with value com.foxit.sdk.pdf.annots.Annot.e_MKEntryNormalCaption to check.

## ◆ getMKNormalIconBitmap()

Bitmap com.foxit.sdk.pdf.annots.Widget.getMKNormalIconBitmap | ( |  | ) | throws com.foxit.sdk.PDFException

Get the normal icon bitmap in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Normal icon in MK dictionary is used to displayed when the widget is not interacting with the user. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Returns
  Normal icon bitmap. If function common.Bitmap.isEmpty for the returned bitmap object returns true, that means current widget annotation does not have normal icon bitmap.

## ◆ getMKRolloverCaption()

String com.foxit.sdk.pdf.annots.Widget.getMKRolloverCaption | ( |  | ) | throws com.foxit.sdk.PDFException

Get the rollover caption string in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Rollover caption in MK dictionary is used to displayed when the user rolls the cursor into its active area without pressing the mouse button. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Returns
  Rollover caption string. An empty string may means no rollover caption in MK dictionary. In this case, please call function Widget.hasMKEntry with value com.foxit.sdk.pdf.annots.Annot.e_MKEntryRolloverCaption to check.

## ◆ getMKRolloverIconBitmap()

Bitmap com.foxit.sdk.pdf.annots.Widget.getMKRolloverIconBitmap | ( |  | ) | throws com.foxit.sdk.PDFException

Get the rollover icon bitmap in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Rollover icon in MK dictionary is used to displayed when the user rolls the cursor into its active area without pressing the mouse button. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Returns
  Rollover icon bitmap. If function common.Bitmap.isEmpty for the returned bitmap object returns true, that means current widget annotation does not have rollover icon bitmap.

## ◆ getMKRotation()

int com.foxit.sdk.pdf.annots.Widget.getMKRotation | ( |  | ) | throws com.foxit.sdk.PDFException

Get the rotation value in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. The rotation in MK dictionary specifies the degrees by which the widget annotation is rotated counterclockwise relative to the page.

Returns
  The rotation value in MK dictionary. Please refer to values starting from com.foxit.sdk.common.Constants.e_Rotation0 and this would be one of these values. Value com.foxit.sdk.common.Constants.e_RotationUnknown means no rotation in MK dictionary. Specially, returned rotation value represents in counterclockwise.

## ◆ hasMKEntry()

boolean com.foxit.sdk.pdf.annots.Widget.hasMKEntry | ( | int | mk_entry | ) | throws com.foxit.sdk.PDFException

Check if a specified entry exists in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page.

Parameters

  [in] | mk_entry | An entry in MK dictionary. Please refer to values starting from com.foxit.sdk.pdf.annots.Annot.e_MKEntryRotation and this should be one of these values.

Returns
  true means the specified entry exists in the MK dictionary, while false means not.

## ◆ removeAction()

void com.foxit.sdk.pdf.annots.Widget.removeAction | ( |  | ) | throws com.foxit.sdk.PDFException

Remove action.

This function cannot be used to remove action which is used as additional action. If user wants to remove any additional action, please refer to class com.foxit.sdk.pdf.actions.AdditionalAction for more details.

Returns
  None.

## ◆ removeMKEntry()

void com.foxit.sdk.pdf.annots.Widget.removeMKEntry | ( | int | mk_entry | ) | throws com.foxit.sdk.PDFException

Remove a specified entry from the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page.

Parameters

  [in] | mk_entry | An entry in MK dictionary. Please refer to values starting from com.foxit.sdk.pdf.annots.Annot.e_MKEntryRotation and this should be one of these values.

Returns
  None.

## ◆ setAction()

void com.foxit.sdk.pdf.annots.Widget.setAction | ( | Action | action | ) | throws com.foxit.sdk.PDFException

Set action.

This function cannot be used to set action which is used as additional action. If user wants to set any additional action, please refer to class com.foxit.sdk.pdf.actions.AdditionalAction for more details.

Parameters

  [in] | action | New action to be set. It should be valid. Currently only support following types as the new action: com.foxit.sdk.pdf.actions.Action.e_TypeGoto , com.foxit.sdk.pdf.actions.Action.e_TypeURI , com.foxit.sdk.pdf.actions.Action.e_TypeJavaScript , com.foxit.sdk.pdf.actions.Action.e_TypeNamed , com.foxit.sdk.pdf.actions.Action.e_TypeGoToR , com.foxit.sdk.pdf.actions.Action.e_TypeGoToE , com.foxit.sdk.pdf.actions.Action.e_TypeSubmitForm , com.foxit.sdk.pdf.actions.Action.e_TypeResetForm , com.foxit.sdk.pdf.actions.Action.e_TypeHide , com.foxit.sdk.pdf.actions.Action.e_TypeLaunch , com.foxit.sdk.pdf.actions.Action.e_TypeImportData , com.foxit.sdk.pdf.actions.Action.e_TypeRendition .

Returns
  None.

## ◆ setAppearanceState()

void com.foxit.sdk.pdf.annots.Widget.setAppearanceState | ( | String | appearance_state | ) | throws com.foxit.sdk.PDFException

Set the annotation's appearance state, which selects the applicable appearance stream from an appearance subdictionary.

Parameters

  [in] | appearance_state | The annotation's appearance state.

Returns
  None.

## ◆ setHighlightingMode()

void com.foxit.sdk.pdf.annots.Widget.setHighlightingMode | ( | int | mode | ) | throws com.foxit.sdk.PDFException

Set highlighting mode.

Highlighting mode is the visual effect to be used when the mouse button is pressed or held down inside its active area.

Parameters

  [in] | mode | New highlighting mode value. Please refer to values starting from com.foxit.sdk.pdf.annots.Annot.e_HighlightingNone and this should be one of these values.

Returns
  None.

## ◆ setLineSpacing()

void com.foxit.sdk.pdf.annots.Widget.setLineSpacing | ( | int | line_spacing_style,
|  | float | line_spacing_value
| ) |  | throws com.foxit.sdk.PDFException

Set line spacing for current widget.

This is only applicable for widget associated with text fields which contain the flag com.foxit.sdk.pdf.interform.Field.e_FlagTextMultiline . For other type of fields, this will be useless.

Parameters

  [in] | line_spacing_style | Line spacing style to be set to current widget.Please refer to values starting from com.foxit.sdk.pdf.annots.Widget.e_LineSpacingSingle and this would be one of these values.
  [in] | line_spacing_value | Line spacing exact value to be set to current widget when parameter line_spacing_style is com.foxit.sdk.pdf.annots.Widget.e_LineSpacingExactValue . When this parameter is useful, this parameter must be an non-negative value and the unit should be "pt" (known as point). If this value is zero, the effect of line spacing will be the same as single line spacing.

Returns
  None.

## ◆ setMKBackgroundColor()

void com.foxit.sdk.pdf.annots.Widget.setMKBackgroundColor | ( | long | color | ) | throws com.foxit.sdk.PDFException

Set the background color in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page.

Parameters

  [in] | color | The background color to be set in MK dictionary. Value format: 0xRRGGBB.

Returns
  None.

## ◆ setMKBorderColor()

void com.foxit.sdk.pdf.annots.Widget.setMKBorderColor | ( | long | color | ) | throws com.foxit.sdk.PDFException

Set the border color in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page.

Parameters

  [in] | color | The border color to be set in MK dictionary. Value format: 0xRRGGBB.

Returns
  None.

## ◆ setMKDownCaption()

void com.foxit.sdk.pdf.annots.Widget.setMKDownCaption | ( | String | caption | ) | throws com.foxit.sdk.PDFException

Set the down caption string in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Down caption (or alternate caption) in MK dictionary is used to displayed when the mouse button is pressed within its active area. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | caption | Down caption string to be set in MK dictionary. It can be an empty string.

Returns
  None.

## ◆ setMKDownIconBitmap()

void com.foxit.sdk.pdf.annots.Widget.setMKDownIconBitmap | ( | Bitmap | bitmap | ) | throws com.foxit.sdk.PDFException

Set the down icon bitmap in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Down icon (or alternate icon) in MK dictionary is used to displayed when the mouse button is pressed within its active area. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | bitmap | A valid bitmap to be set as down icon in MK dictionary.

Returns
  None.

## ◆ setMKDownIconImage()

void com.foxit.sdk.pdf.annots.Widget.setMKDownIconImage | ( | Image | image,
|  | int | frame_index
| ) |  | throws com.foxit.sdk.PDFException

Set an image with specified frame index as down icon in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Down icon (or alternate icon) in MK dictionary is used to displayed when the mouse button is pressed within its active area. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | image | An image. One of its frames will be set as down icon in MK dictionary. This image should contain at least one frame and the image type should not be com.foxit.sdk.common.Image.e_Unknown .
  [in] | frame_index | Frame index. Valid range: from 0 to (count-1). count is returned by function common.Image.getFrameCount .

## ◆ setMKIconCaptionRelation()

void com.foxit.sdk.pdf.annots.Widget.setMKIconCaptionRelation | ( | int | relation | ) | throws com.foxit.sdk.PDFException

Set the relation of icon and caption in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. The relation position of caption and icon specifies where to position the text of the widget annotation's caption relative to its icon. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | relation | The relation position of caption and icon. Please refer to values starting from com.foxit.sdk.pdf.annots.Annot.e_MKRelationNoIcon and this should be one of these values.

Returns
  None.

## ◆ setMKIconFit()

void com.foxit.sdk.pdf.annots.Widget.setMKIconFit | ( | IconFit | icon_fit | ) | throws com.foxit.sdk.PDFException

Set the icon fit information in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. The icon fit information specifies how to display the widget annotation's icon within its annotation rectangle. If present, the icon fit information applies to all of the annotation's icons. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | icon_fit | An icon fit object which represents the icon fit information to be set in MK dictionary. If value of any member in this object is invalid, this function will throw exception com.foxit.sdk.common.Constants.e_ErrParam . Please refer to class IconFit to check the valid value range for each member.

Returns
  None.

## ◆ setMKNormalCaption()

void com.foxit.sdk.pdf.annots.Widget.setMKNormalCaption | ( | String | caption | ) | throws com.foxit.sdk.PDFException

Set the normal caption string in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Normal caption in MK dictionary is used to displayed when the widget is not interacting with the user. This is applicable for widgets associated with pushbutton field, check box field or radio button field. For other type of fields, this will be useless.

Parameters

  [in] | caption | Normal caption string to be set in MK dictionary. It can be an empty string.

Returns
  None.

## ◆ setMKNormalIconBitmap()

void com.foxit.sdk.pdf.annots.Widget.setMKNormalIconBitmap | ( | Bitmap | bitmap | ) | throws com.foxit.sdk.PDFException

Set a bitmap as normal icon in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Normal icon in MK dictionary is used to displayed when the widget is not interacting with the user. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | bitmap | A valid bitmap to be set as normal icon in MK dictionary.

Returns
  None.

## ◆ setMKNormalIconImage()

void com.foxit.sdk.pdf.annots.Widget.setMKNormalIconImage | ( | Image | image,
|  | int | frame_index
| ) |  | throws com.foxit.sdk.PDFException

Set an image with specified frame index as normal icon in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Normal icon in MK dictionary is used to displayed when the widget is not interacting with the user. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | image | An image. One of its frames will be set as normal icon in MK dictionary. This image should contain at least one frame and the image type should not be com.foxit.sdk.common.Image.e_Unknown .
  [in] | frame_index | Frame index. Valid range: from 0 to (count-1). count is returned by function common.Image.getFrameCount .

## ◆ setMKRolloverCaption()

void com.foxit.sdk.pdf.annots.Widget.setMKRolloverCaption | ( | String | caption | ) | throws com.foxit.sdk.PDFException

Set the rollover caption string in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Rollover caption in MK dictionary is used to displayed when the user rolls the cursor into its active area without pressing the mouse button. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | caption | Rollover caption string to be set in MK dictionary. It can be an empty string.

Returns
  None.

## ◆ setMKRolloverIconBitmap()

void com.foxit.sdk.pdf.annots.Widget.setMKRolloverIconBitmap | ( | Bitmap | bitmap | ) | throws com.foxit.sdk.PDFException

Set the rollover icon bitmap in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Rollover icon in MK dictionary is used to displayed when the user rolls the cursor into its active area without pressing the mouse button. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | bitmap | A valid bitmap to be set as rollover icon in MK dictionary.

Returns
  None.

## ◆ setMKRolloverIconImage()

void com.foxit.sdk.pdf.annots.Widget.setMKRolloverIconImage | ( | Image | image,
|  | int | frame_index
| ) |  | throws com.foxit.sdk.PDFException

Set an image with specified frame index as rollover icon in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. Rollover icon in MK dictionary is used to displayed when the user rolls the cursor into its active area without pressing the mouse button. This is applicable for widget associated with pushbutton field. For other type of fields, this will be useless.

Parameters

  [in] | image | An image. One of its frames will be set as rollover icon in MK dictionary. This image should contain at least one frame and the image type should not be com.foxit.sdk.common.Image.e_Unknown .
  [in] | frame_index | Frame index. Valid range: from 0 to (count-1). count is returned by function common.Image.getFrameCount .

## ◆ setMKRotation()

void com.foxit.sdk.pdf.annots.Widget.setMKRotation | ( | int | rotation | ) | throws com.foxit.sdk.PDFException

Set the rotation value in the MK dictionary.

MK dictionary is an appearance characteristics dictionary to be used in constructing a dynamic appearance stream specifying the annotation's visual presentation on the page. The rotation in MK dictionary specifies the degrees by which the widget annotation is rotated counterclockwise relative to the page.

Parameters

  [in] | rotation | The rotation value to be set in MK dictionary. Please refer to values starting from com.foxit.sdk.common.Constants.e_Rotation0 and this should be one of these values except com.foxit.sdk.common.Constants.e_RotationUnknown . Specially, rotation value here represents in counterclockwise.